For AI agents: a documentation index is available at the root level at /llms.txt and /llms-full.txt. Append /llms.txt to any URL for a page-level index, or .md for the markdown version of any page.
Dev Portal
DocsAPI ReferenceLearnCommunityChangelog
DocsAPI ReferenceLearnCommunityChangelog
    • About Our APIs
  • REST
    • Overview
      • Overview
        • Abandoned Carts
        • Carts
        • Channels
        • Checkouts
        • Currencies
          • V3
              • GETList Customers
              • POSTCreate Customers
              • PUTUpdate Customers
              • DELDelete Customers
                • GETList Customer Metafields
                • POSTCreate Customer Metafields
                • GETGet Customer Metafield
                • PUTUpdate Metafield
                • DELDelete Customer Metafield
          • V2
        • Customer Segmentation
        • Geography
        • Infrastructure Hosting
        • Inventory
        • Orders
        • Order Operations
        • Pickup
        • Pickup Methods
        • Pickup Options
        • Pricing
        • Price Lists
        • Promotions
        • Promotion Settings
        • Redirects
        • Scripts
        • Settings
        • Shipping
        • Sites
        • Subscribers
        • System Logs
        • Tax
        • Wishlists
      • Payments
  • GraphQL
    • Overview
  • MCP
    • Overview
Dev Portal
LogoLogo
RESTAdminManagementCustomersV3Metafields

Create Customer Metafields

POST
https://api.bigcommerce.com/stores/:store_hash/v3/customers/:customerId/metafields
POST
/stores/:store_hash/v3/customers/:customerId/metafields
$curl -X POST https://api.bigcommerce.com/stores/store_hash/v3/customers/1/metafields \
> -H "X-Auth-Token: <apiKey>" \
> -H "Content-Type: application/json" \
> -d '{
> "permission_set": "app_only",
> "namespace": "Sales Department",
> "key": "Staff Name",
> "value": "Ronaldo"
>}'
1{
2 "data": [
3 {
4 "permission_set": "app_only",
5 "namespace": "Sales Department",
6 "key": "Staff Name",
7 "value": "Ronaldo",
8 "description": "order",
9 "resource_type": "cart",
10 "resource_id": 424242,
11 "id": 1,
12 "date_created": "2022-06-16T18:39:00+00:00",
13 "date_modified": "2022-06-16T18:39:00+00:00",
14 "owner_client_id": "ramciw4fnoz87it3ynjfif2zrkil5p"
15 }
16 ],
17 "errors": [],
18 "meta": {
19 "pagination": {
20 "total": 36,
21 "count": 36,
22 "per_page": 50,
23 "current_page": 1,
24 "total_pages": 1,
25 "links": {
26 "previous": "string",
27 "current": "?page=1&limit=50",
28 "next": "string"
29 }
30 }
31 }
32}

Creates Customer metafields by passing the customerId in the query parameters.

Was this page helpful?
Previous

List Customer Metafields

Next

Get Customer Metafield

Built with

Authentication

X-Auth-Tokenstring
### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Customers | modify | `store_v2_customers` | | Customers | read-only | `store_v2_customers_read_only` | | Stored Payment Instruments | modify | `store_stored_payment_instruments` | | Stored Payment Instruments | read-only | `store_stored_payment_instruments_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

Path parameters

customerIdintegerRequired
The ID of the customer.
store_hashstringRequired
Permanent ID of the BigCommerce store.

Request

This endpoint expects an object.
permission_setenumRequired

Determines the visibility and writeability of the field by other API consumers.

ValueDescription
app_onlyPrivate to the app that owns the field.
readVisible to other API consumers.
writeOpen for reading and writing by other API consumers.
read_and_sf_accessVisible to other API consumers, including on the storefront.
write_and_sf_accessOpen for reading and writing by other API consumers, including on the storefront.
Allowed values:
namespacestringRequired1-64 characters
Namespace for the metafield, for organizational purposes.
keystringRequired1-64 characters

The name of the field, for example: location_id, color.

valuestringRequired1-65535 characters

The value of the field, for example: 1, blue.

descriptionstringOptional0-255 characters
Description for the metafields.

Response

Response payload for the BigCommerce API.
datalist of objects
errorslist of any
Empty for 200 responses.
metaobject
Data about the response, including pagination and collection totals.

Errors

400
Bad Request Error
409
Conflict Error
422
Unprocessable Entity Error

OAuth scopes

UI NamePermissionParameter
Customersmodifystore_v2_customers
Customersread-onlystore_v2_customers_read_only
Stored Payment Instrumentsmodifystore_stored_payment_instruments
Stored Payment Instrumentsread-onlystore_stored_payment_instruments_read_only

Authentication header

HeaderArgumentDescription
X-Auth-Tokenaccess_tokenFor more about API accounts that generate access_tokens, see our Guide to API Accounts.

Further reading

For example requests and more information about authenticating BigCommerce APIs, see Authentication and Example Requests.

For more about BigCommerce OAuth scopes, see our Guide to API Accounts.

For a list of API status codes, see API Status Codes.